VERSION 2.00
Begin Form MainForm 
   Caption         =   "NE COBOL Editor"
   ClientHeight    =   6765
   ClientLeft      =   2355
   ClientTop       =   1260
   ClientWidth     =   9000
   FontBold        =   0   'False
   FontItalic      =   0   'False
   FontName        =   "Courier New"
   FontSize        =   8.25
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   7455
   Icon            =   MAINFORM.FRX:0000
   Left            =   2295
   LinkTopic       =   "Form1"
   ScaleHeight     =   6765
   ScaleWidth      =   9000
   Top             =   630
   Width           =   9120
   Begin Frame IdentificationAreaEndFrame 
      BackColor       =   &H00000000&
      Caption         =   "Frame5"
      ForeColor       =   &H00000000&
      Height          =   6915
      Left            =   8520
      TabIndex        =   5
      Top             =   60
      Width           =   15
   End
   Begin Frame IdentificationAreaFrame 
      BackColor       =   &H00000000&
      ForeColor       =   &H00000000&
      Height          =   6855
      Left            =   7680
      TabIndex        =   4
      Top             =   60
      Width           =   15
   End
   Begin Frame AreaBFrame 
      BackColor       =   &H00000000&
      ForeColor       =   &H00000000&
      Height          =   6975
      Left            =   1260
      TabIndex        =   3
      Top             =   60
      Width           =   15
   End
   Begin Frame AreaAFrame 
      BackColor       =   &H00000000&
      ForeColor       =   &H00000000&
      Height          =   6855
      Left            =   840
      TabIndex        =   2
      Top             =   60
      Width           =   15
   End
   Begin Frame CommentFrame 
      BackColor       =   &H00000000&
      ForeColor       =   &H00000000&
      Height          =   6855
      Left            =   720
      TabIndex        =   1
      Top             =   60
      Width           =   15
   End
   Begin TextBox EditorText 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Courier New"
      FontSize        =   9
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   6495
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789"
      Top             =   60
      Width           =   8895
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu NewMenuItem 
         Caption         =   "&New File"
         Index           =   0
         Shortcut        =   ^N
      End
      Begin Menu OpenFileMenuItem 
         Caption         =   "&Open File"
         Shortcut        =   ^O
      End
      Begin Menu DeleteFileMenuItem 
         Caption         =   "&Delete File"
      End
      Begin Menu FileSpacer2MenuItem 
         Caption         =   "-"
      End
      Begin Menu SaveMenuItem 
         Caption         =   "&Save"
         Index           =   1
         Shortcut        =   ^S
      End
      Begin Menu SaveAsMenuItem 
         Caption         =   "Save &As"
         Shortcut        =   ^A
      End
      Begin Menu FileSpacerMenuItem 
         Caption         =   "-"
      End
      Begin Menu QuitMenuItem 
         Caption         =   "E&xit"
         Index           =   2
      End
   End
   Begin Menu EditMenu 
      Caption         =   "&Edit"
      Begin Menu FontMenuItem 
         Caption         =   "F&ont..."
      End
      Begin Menu EditSpaceMenuItem 
         Caption         =   "-"
      End
      Begin Menu UpperCaseMenuItem 
         Caption         =   "Convert Text to &Uppercase"
      End
      Begin Menu LowercaseMenuItem 
         Caption         =   "Convert Text to &Lowercase"
      End
      Begin Menu EditSpaceMenuItem2 
         Caption         =   "-"
      End
      Begin Menu ConvertTabsMenuItem 
         Caption         =   "Convert All &Tabs to Spaces"
      End
      Begin Menu EditSpaceMenuItem3 
         Caption         =   "-"
      End
      Begin Menu FindMenuItem 
         Caption         =   "&Find..."
         Shortcut        =   ^F
      End
      Begin Menu FindNextMenuItem 
         Caption         =   "Find &Next"
         Shortcut        =   {F3}
      End
   End
   Begin Menu DirectoryMenu 
      Caption         =   "&Directory"
      Begin Menu CreateDirectoryMenuItem 
         Caption         =   "&Create Directory..."
      End
      Begin Menu DeleteDirectoryMenuItem 
         Caption         =   "&Delete Directory"
      End
   End
   Begin Menu OptionsMenu 
      Caption         =   "&Options"
      Begin Menu FreeFormatMenuItem 
         Caption         =   "&Free Format"
         Checked         =   -1  'True
         Shortcut        =   {F2}
      End
      Begin Menu SmartIndentingMenuItem 
         Caption         =   "Smart &Indenting"
         Checked         =   -1  'True
      End
      Begin Menu OptionsSpacerMenuOption 
         Caption         =   "-"
      End
      Begin Menu ConvertTabsDuringSaveMenuItem 
         Caption         =   "&Convert Tabs to Spaces When Saving"
         Checked         =   -1  'True
      End
      Begin Menu OptionsSpacerMenuOption2 
         Caption         =   "-"
      End
      Begin Menu ShowFileControlsMenuOption 
         Caption         =   "&Show File Controls"
         Checked         =   -1  'True
         Shortcut        =   {F6}
      End
   End
   Begin Menu RunMenu 
      Caption         =   "&Run"
      Begin Menu RunMenuItem 
         Caption         =   "&Run Batch or Executable..."
         Shortcut        =   {F5}
      End
   End
   Begin Menu HelpMenu 
      Caption         =   "&Help"
      Index           =   1
      Begin Menu AboutMenuItem 
         Caption         =   "&About"
         Index           =   3
         Shortcut        =   {F1}
      End
   End
End
Dim FinalCursorPos As Integer

Sub AboutMenuItem_Click (Index As Integer)
    AboutForm.Visible = True
End Sub

Sub ConvertTabsDuringSaveMenuItem_Click ()
    Call SetTabConvertEnabled(Not ConvertTabsDuringSaveMenuItem.Checked)
End Sub

Sub ConvertTabsMenuItem_Click ()
    Dim TextToConvert As String
    TextToConvert = EditorText.Text
    EditorText.Text = ConvertTabsToSpaces$(TextToConvert)
End Sub

Sub CreateDirectoryMenuItem_Click ()
    CreateDirForm.Visible = True
    MainForm.Enabled = False
    FileControlForm.Enabled = False
End Sub

Sub DeleteDirectoryMenuItem_Click ()
    Call DeleteSelectedDirectory
End Sub

Sub DeleteFileMenuItem_Click ()
    Call DeleteSelectedFile
End Sub

Sub EditorText_KeyUp (KeyCode As Integer, Shift As Integer)
    
    If Not SmartIndentingMenuItem.Checked Then
	Exit Sub
    End If
    
    If KeyCode = ENTER_KEY Then
	Dim i As Integer
	Dim idx As Integer
	Dim StartIdx As Integer
	Dim CurFoundIdx As Integer
	Dim LastFoundIdx As Integer
	
	'end of area to check is where cursor is.
	idx = EditorText.SelStart
	
	'only check past 80 chars for speed reasons.
	StartIdx = idx - 80

	If StartIdx < 1 Then StartIdx = 1
	
	CurFoundIdx = 0
	LastFoundIdx = 1 'to avoid mid searching from zero when not found.

	Dim SearchText As String
	SearchText = Mid$(EditorText.Text, StartIdx, 80)

	'find last new line location in text.
	For i = 1 To Len(SearchText)
	     CurFoundIdx = InStr(i, SearchText, Chr$(10))
	     If CurFoundIdx Then
		LastFoundIdx = CurFoundIdx + 1
		i = LastFoundIdx 'jump i ahead
	     End If
	Next i

	Dim PrevLine As String
	Dim LenOfPrevLine As Integer
	Dim TestChar As String
	Dim SubStr As String

	LenOfPrevLine = Len(SearchText) - LastFoundIdx
	If LenOfPrevLine < 1 Then Exit Sub 'nothing to do
	
	PrevLine = Mid$(SearchText, LastFoundIdx, LenOfPrevLine)

	For i = 1 To Len(PrevLine)
	    
	    'get next charater in string to test.
	    TestChar = Mid$(PrevLine, i, 1)
	    
	    'if not a space or tab, it's start of text. exit.
	    If TestChar <> " " And TestChar <> TAB_CHAR Then
		Exit For
	    End If
	Next i
	
	'copy beginning of prev line to next line.
	SubStr = Left$(PrevLine, i - 1)
	
	'update output text
	EditorText.Text = Left$(EditorText.Text, idx) + SubStr + Right$(EditorText.Text, Len(EditorText.Text) - idx)
	EditorText.SelStart = idx + Len(SubStr)
    End If

End Sub

Sub FindMenuItem_Click ()
    FindForm.Visible = True
End Sub

Sub FindNextMenuItem_Click ()
If Not SearchText%(PREV_SEARCH_IDX, PREV_SEARCH_TEXT) Then
	If PREV_SEARCH_IDX <> 1 Then
	    
	    Dim Retry As Integer
	    
	    Retry = MsgBox("No matches found." & NEW_LINE & "Search from beginning of file?", MB_YESNO + MB_ICONEXCLAMATION, "Not Found")
	    If Retry = IDYES Then
		PREV_SEARCH_IDX = 1
		Call FindNextMenuItem_Click
	    End If
	Else
	    MsgBox "No matches found.", MB_ICONEXCLAMATION, "Not Found"
	End If
    End If
End Sub

Sub FontMenuItem_Click ()
    MainForm.Enabled = False
    FileControlForm.Enabled = False
    FontForm.Visible = True
End Sub

Sub Form_Load ()
    EditorText.Text = GetFileTemplate$(TEMPLATE_TYPE_SOURCE)
    FreeFormatMenuItem.Checked = False
    ConvertTabsDuringSaveMenuItem.Checked = IsTabConvertEnabled%()
End Sub

Sub Form_Resize ()

    If MainForm.Height <= 1000 Then
	Exit Sub
    End If
    
    EditorText.Height = MainForm.Height - 1000
    
    ResizedWidth% = MainForm.Width - MainForm.Left - 400
    If ResizedWidth% > 8900 Then
	EditorText.Width = ResizedWidth%
    Else
	EditorText.Width = 8900
    End If

    LineHeight% = EditorText.Height - 250

    CommentFrame.Height = LineHeight%
    AreaAFrame.Height = LineHeight%
    AreaBFrame.Height = LineHeight%
    IdentificationAreaFrame.Height = LineHeight%
    IdentificationAreaEndFrame.Height = LineHeight%
End Sub

Sub Form_Unload (Cancel As Integer)
    
    Dim Contents As String
    Contents = EditorText.Text

    If IsSaveReq%(Contents) Then
	Dim Confirm As Integer
	Dim OpenFileName As String

	OpenFileName = GetPreviousFileName$()
	Confirm = MsgBox("Changes to " & OpenFileName & " are not saved." & NEW_LINE & NEW_LINE & "Do you want to save the changes?", MB_YESNOCANCEL + MB_ICONEXCLAMATION, "Exit")
	If Confirm = IDYES Then
	    MainForm.Enabled = False
	    'flag will cause save window to end program
	    'on unload
	    IS_QUIT = True
	    SaveFileForm.Visible = True
	    Cancel = True
	ElseIf Confirm = IDCANCEL Then
	    Cancel = True
	End If
    End If

    If Not Cancel Then
	End
    End If

End Sub

Sub FreeFormatMenuItem_Click ()
    
    Dim isChecked As Integer
    isChecked = Not FreeFormatMenuItem.Checked
    Call IsFreeFormatMode(isChecked)
    
End Sub

Sub LowercaseMenuItem_Click ()
    EditorText.Text = LCase$(EditorText.Text)
End Sub

Sub NewMenuItem_Click (Index As Integer)
    NewFileForm.Visible = True
    MainForm.Enabled = False
    FileControlForm.Enabled = False
End Sub

Sub OpenFileMenuItem_Click ()
    
    'check if file changed. If so, ask to save.
    Dim CurContents As String
    CurContents = MainForm.EditorText.Text
    If IsSaveReq%(CurContents) Then

	Dim DisplayFileName As String
	DisplayFileName = GetPreviousFileName$()
	
	Dim SaveChanges As Integer
	SaveChanges = MsgBox(GetPreviousFileName$() & " has been modified. Save changes?", MB_YESNO + MB_ICONQUESTION, "Save Changes?")
	If SaveChanges = IDYES Then
	    If GetPreviousFileName$() <> NEW_FILE_STR Then
		Call SavePreviousFile(CurContents$)
	    Else
		SaveFileForm.Visible = True
		MainForm.Enabled = False
		FileControlForm.Enabled = False
		'Mainform will be re-enabled when save file form
		'is closed.
		Exit Sub
	    End If
	    Exit Sub
	End If
    End If

    MainForm.Enabled = False
    FileControlForm.Enabled = False
    OpenFileForm.Visible = True
End Sub

Sub QuitMenuItem_Click (Index As Integer)
    Unload MainForm
End Sub

Sub RunMenuItem_Click ()
    RunForm.Visible = True
End Sub

Sub SaveAsMenuItem_Click ()
    MainForm.Enabled = False
    FileControlForm.Enabled = False
    SaveFileForm.Visible = True
End Sub

Sub SaveMenuItem_Click (Index As Integer)
    
    CurContents$ = EditorText.Text

    If GetPreviousFileName$() <> NEW_FILE_STR Then
	Call SavePreviousFile(CurContents$)
    Else
	SaveFileForm.Visible = True
	MainForm.Enabled = False
	FileControlForm.Enabled = False
	'Mainform will be re-enabled when save file form
	'is closed.
    End If
    
End Sub

Sub ShowFileControlsMenuOption_Click ()
    Call ToggleFileControls
End Sub

Sub SmartIndentingMenuItem_Click ()
    SmartIndentingMenuItem.Checked = Not SmartIndentingMenuItem.Checked
End Sub

Sub UpperCaseMenuItem_Click ()
    EditorText.Text = UCase$(EditorText.Text)
End Sub

