VERSION 2.00
Begin Form NewFileForm 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Create New File"
   ClientHeight    =   1575
   ClientLeft      =   3645
   ClientTop       =   3705
   ClientWidth     =   2790
   Height          =   1980
   Left            =   3585
   LinkTopic       =   "NewFileForm"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1575
   ScaleWidth      =   2790
   Top             =   3360
   Width           =   2910
   Begin OptionButton BuildTemplateOption 
      Caption         =   "MS COBOL &Build Template"
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   420
      Width           =   2535
   End
   Begin CommandButton CancelCommand 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   1440
      TabIndex        =   4
      Top             =   1140
      Width           =   1275
   End
   Begin CommandButton OkCommand 
      Caption         =   "&OK"
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   1140
      Width           =   1275
   End
   Begin OptionButton BlankOption 
      Caption         =   "&Blank File"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   780
      Width           =   1815
   End
   Begin OptionButton TemplateOption 
      Caption         =   "&Source File Template"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2475
   End
End
Option Explicit

Sub BlankOption_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

Sub BuildTemplateOption_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

Sub CancelCommand_Click ()
    Unload NewFileForm
End Sub

Sub Form_Unload (Cancel As Integer)
    MainForm.Enabled = True
    FileControlForm.Enabled = True
End Sub

Sub OkCommand_Click ()
    'check if file changed. If so, ask to save.
    Dim CurContents As String
    Dim DisplayFileName As String

    CurContents = MainForm.EditorText.Text
    If IsSaveReq%(CurContents) Then
        DisplayFileName = GetPreviousFileName$()
        
        Dim SaveChanges As Integer
        SaveChanges = MsgBox(DisplayFileName & " has been modified. Save changes?", MB_YESNO + MB_ICONQUESTION, "Save Changes?")
        If SaveChanges = IDYES Then
            If DisplayFileName <> NEW_FILE_STR Then
                Call SavePreviousFile(CurContents)
            Else
                SaveFileForm.Visible = True
                MainForm.Enabled = False
                'Mainform will be re-enabled when save file form
                'is closed.
                Exit Sub
            End If
        End If
    End If
    
    OkCommand.Enabled = False
    CancelCommand.Enabled = False

    If TemplateOption.Value Then
        MainForm.EditorText.Text = GetFileTemplate$(TEMPLATE_TYPE_SOURCE)
        Call ResetFileValues(TEMPLATE_TYPE_SOURCE)
        Dim FontSize As Single
        FontSize = MainForm.EditorText.FontSize
        If FontSize < 8.25 Or FontSize > 9 Then
            Call IsFreeFormatMode(True)
        Else
            Call IsFreeFormatMode(False)
        End If

        
    ElseIf BuildTemplateOption.Value Then
        MainForm.EditorText.Text = GetFileTemplate$(TEMPLATE_TYPE_BUILD)
        Call ResetFileValues(TEMPLATE_TYPE_BUILD)
        Call IsFreeFormatMode(True)
    Else
        MainForm.EditorText.Text = ""
        Call ResetFileValues(TEMPLATE_TYPE_NONE)
    End If

    Unload NewFileForm
End Sub

Sub TemplateOption_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

