VERSION 2.00
Begin Form FontForm 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Change Font"
   ClientHeight    =   990
   ClientLeft      =   4110
   ClientTop       =   2880
   ClientWidth     =   3210
   Height          =   1395
   Left            =   4050
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   990
   ScaleWidth      =   3210
   Top             =   2535
   Width           =   3330
   Begin CheckBox ItalicCheck 
      Caption         =   "&Italic"
      Height          =   315
      Left            =   960
      TabIndex        =   5
      Top             =   480
      Width           =   915
   End
   Begin CheckBox BoldCheck 
      Caption         =   "&Bold"
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   480
      Width           =   795
   End
   Begin TextBox FontSizeText 
      Height          =   315
      Left            =   960
      TabIndex        =   3
      Text            =   "999"
      Top             =   120
      Width           =   975
   End
   Begin CommandButton CancelCommand 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   2040
      TabIndex        =   1
      Top             =   540
      Width           =   1095
   End
   Begin CommandButton OkCommand 
      Caption         =   "&OK"
      Height          =   315
      Left            =   2040
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
   Begin Label FontSizeLabel 
      Caption         =   "Font Size:"
      Height          =   315
      Left            =   60
      TabIndex        =   2
      Top             =   180
      Width           =   915
   End
End
Option Explicit

Sub BoldCheck_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

Sub CancelCommand_Click ()
    Unload FontForm
End Sub

Sub FontSizeText_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

Sub Form_Load ()
    
    'absolute value because FontBold/FontItalic return
    'True(-1) or False(0) and CheckBox.Value uses 1 for
    'checked and 0 for unchecked... thanks VB.
    BoldCheck.Value = Abs(MainForm.EditorText.FontBold)
    ItalicCheck.Value = Abs(MainForm.EditorText.FontItalic)
    FontSizeText.Text = MainForm.EditorText.FontSize
End Sub

Sub Form_Unload (Cancel As Integer)
    MainForm.Enabled = True
    FileControlForm.Enabled = True
End Sub

Sub ItalicCheck_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        OkCommand.Value = True
    End If
End Sub

Sub OkCommand_Click ()
    If Not IsNumeric(FontSizeText.Text) Then
        MsgBox "Please enter a valid font size.", MB_ICONEXCLAMATION, "Invalid Font Size"
        Exit Sub
    End If

    Dim NewFontSize As Single
    NewFontSize = Abs(FontSizeText.Text)

    If NewFontSize > 72 Then
        MsgBox "Font size too large. Please enter a smaller font size.", MB_ICONEXCLAMATION, "Invalid Font Size"
        Exit Sub
    End If

    'Fixed format line helpers don't scale with current
    'implementation so turn off fixed mode if font size
    'is not compatible and user wants to change it.
    If Not MainForm.FreeFormatMenuItem.Checked And (NewFontSize < 8.25 Or NewFontSize > 9) Then
        Dim Confirm As Integer
        Confirm = MsgBox("Visual area line helpers in fixed format mode are not compatible with this font size. Are you sure you would like to change the font size?", MB_ICONQUESTION + MB_YESNO, "Change Font?")
        If Confirm <> IDYES Then
            Exit Sub
        Else
            Call IsFreeFormatMode(True)
        End If
    End If

    MainForm.EditorText.FontSize = NewFontSize
    MainForm.EditorText.FontBold = BoldCheck.Value
    MainForm.EditorText.FontItalic = ItalicCheck.Value
    
    Unload FontForm
End Sub

