VERSION 2.00
Begin Form RunForm 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Run"
   ClientHeight    =   1665
   ClientLeft      =   1980
   ClientTop       =   1785
   ClientWidth     =   4215
   Height          =   2070
   Left            =   1920
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1665
   ScaleWidth      =   4215
   Top             =   1440
   Width           =   4335
   Begin CheckBox UseCurrentPathCheck 
      Caption         =   "&Use current path as working directory"
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   780
      Width           =   4035
   End
   Begin CommandButton CancelCommand 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   2100
      TabIndex        =   3
      Top             =   1200
      Width           =   2055
   End
   Begin CommandButton RunCommand 
      Caption         =   "&Run"
      Height          =   315
      Left            =   60
      TabIndex        =   2
      Top             =   1200
      Width           =   1995
   End
   Begin TextBox RunText 
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   360
      Width           =   4095
   End
   Begin Label CommandToRunLabel 
      Caption         =   "Command To Run:"
      Height          =   195
      Left            =   60
      TabIndex        =   4
      Top             =   120
      Width           =   1935
   End
End
Option Explicit

Sub CancelCommand_Click ()
    Unload RunForm
End Sub

Sub Form_Load ()
    RunText.Text = LAST_CMD_RAN
End Sub

Sub RunCommand_Click ()
    Call RunUserCommand
End Sub

Sub RunText_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        Call RunUserCommand
    ElseIf KeyAscii = ESC_KEY Then
        Unload RunForm
    End If
End Sub

Sub RunUserCommand ()
    Dim Cmd As String
    Dim Result As Variant
    
    If RunText.Text = "" Then
        MsgBox "Please enter a file or program name to open.", MB_ICONEXCLAMATION, "Error Running File"
        Exit Sub
    End If

    If UseCurrentPathCheck.Value = 1 Then
        Cmd = FileControlForm.DirControl.Path
        If Right$(Cmd, 1) <> "\" Then
            Cmd = Cmd + "\"
        End If
        Cmd = Cmd + RunText.Text
    Else
        Cmd = RunText.Text
    End If
    
    LAST_CMD_RAN = Cmd

    On Error GoTo ErrorHandler
    Result = Shell(Cmd, 9)

ErrorHandler:   ' Error handler line label.
    Dim Msg As String
    Select Case Err
        Case 0: Exit Sub ' err 0 raises each time. ignore.
        Case 53: Msg = "ERROR 53: File doesn't exist."
        Case 68: Msg = "ERROR 68: Drive not available."
        Case 76: Msg = "ERROR 76: Path doesn't exist."
        Case Else: Msg = "ERROR " & Err & " occurred."
    End Select
    MsgBox Msg, MB_ICONEXCLAMATION, "Error Running File"
    Exit Sub ' Resume procedure.


End Sub

Sub UseCurrentPathCheck_KeyPress (KeyAscii As Integer)
    If KeyAscii = ENTER_KEY Then
        Call RunUserCommand
    ElseIf KeyAscii = ESC_KEY Then
        Unload RunForm
    End If
End Sub

